--- old/usr/src/cmd/cmd-inet/etc/dhcp/inittab	Mon Nov 14 16:21:12 2016
+++ new/usr/src/cmd/cmd-inet/etc/dhcp/inittab	Mon Nov 14 16:21:12 2016
@@ -1,6 +1,7 @@
 #
 # Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 # CDDL HEADER START
 #
@@ -114,6 +115,7 @@
 UserClas	STANDARD,	77,	ASCII,	   1,	0,	sdi
 SLP_DA		STANDARD,	78,	OCTET,	   1,	0,	sdmi
 SLP_SS		STANDARD,	79,	OCTET,	   1,	0,	sdmi
+ClientFQDN	STANDARD,	81,	OCTET,	   1,	0,	sdmi
 AgentOpt	STANDARD,	82,	OCTET,	   1,	0,	sdi
 FQDN		STANDARD,	89,	OCTET,	   1,	0,	sdmi
 
@@ -177,7 +179,7 @@
 # The following option describes an option named ipPairs, that is in
 # the  SITE category, meaning it is defined by each individual site.
 # It is option code 132, which is of type IP Address, consisting of
-# a potentially infinite number of pairs of IP addresses.  (See 
+# a potentially infinite number of pairs of IP addresses.  (See
 # dhcp_inittab(4) for details)
 #
 # ipPairs     SITE,           132,    IP,     2,      0,      sdmi
--- old/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_door.c	Mon Nov 14 16:21:12 2016
+++ new/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_door.c	Mon Nov 14 16:21:12 2016
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 /*
@@ -225,8 +226,6 @@
 	char			*aobjname = NULL, *ifname = NULL;
 	int32_t			lnum;
 	nvlist_t		*nvladdr;
-	struct sockaddr_storage	addr;
-	uint_t			n;
 	sa_family_t		af = AF_UNSPEC;
 	ipadm_addr_type_t	addrtype = IPADM_ADDR_NONE;
 	int			err = 0;
@@ -244,16 +243,42 @@
 	if (nvlist_exists(nvl, IPADM_NVP_IPV4ADDR)) {
 		af = AF_INET;
 		addrtype = IPADM_ADDR_STATIC;
-	} else if (nvlist_exists(nvl, IPADM_NVP_DHCP)) {
+	} else if (nvlist_lookup_nvlist(nvl, IPADM_NVP_DHCP, &nvladdr) == 0) {
+		char	*reqhost;
+		boolean_t	primary;
+
 		af = AF_INET;
 		addrtype = IPADM_ADDR_DHCP;
+
+		if (nvlist_lookup_boolean_value(nvladdr, IPADM_NVP_PRIMARY,
+		    &primary) != 0)
+			return (EINVAL);
+		nodep->ipmgmt_am_primary = primary;
+
+		/*
+		 * ipmgmt_am_reqhost comes through in `nvl' for purposes of updating
+		 * the cached representation, but it is persisted as a stand-alone
+		 * DB line; so remove it after copying it.
+		 */
+		if (!nvlist_exists(nvl, IPADM_NVP_REQHOST)) {
+			*nodep->ipmgmt_am_reqhost = '\0';
+		} else {
+			if ((err = nvlist_lookup_string(nvl, IPADM_NVP_REQHOST,
+			    &reqhost)) != 0)
+				return (err);
+
+			(void) strlcpy(nodep->ipmgmt_am_reqhost, reqhost,
+			    sizeof (nodep->ipmgmt_am_reqhost));
+			(void) nvlist_remove(nvl, IPADM_NVP_REQHOST, DATA_TYPE_STRING);
+		}
 	} else if (nvlist_exists(nvl, IPADM_NVP_IPV6ADDR)) {
 		af = AF_INET6;
 		addrtype = IPADM_ADDR_STATIC;
 	} else if (nvlist_lookup_nvlist(nvl, IPADM_NVP_INTFID, &nvladdr) == 0) {
-		struct sockaddr_in6 *sin6 = (struct sockaddr_in6 *)&addr;
+		struct sockaddr_in6		sin6 = {0};
 		uint8_t	*addr6;
 		uint32_t plen;
+		uint_t n;
 
 		af = AF_INET6;
 		addrtype = IPADM_ADDR_IPV6_ADDRCONF;
@@ -264,14 +289,15 @@
 			if (nvlist_lookup_uint8_array(nvladdr,
 			    IPADM_NVP_IPNUMADDR, &addr6, &n) != 0)
 				return (EINVAL);
-			bcopy(addr6, &sin6->sin6_addr, n);
-		} else {
-			bzero(&sin6->sin6_addr, sizeof (sin6->sin6_addr));
+			bcopy(addr6, &sin6.sin6_addr, n);
 		}
+
+		nodep->ipmgmt_am_linklocal = B_TRUE;
+		nodep->ipmgmt_am_ifid = sin6;
 	}
 
 	/*
-	 * populate the `*nodep' with retrieved values.
+	 * populate the non-addrtype-specific `*nodep' with retrieved values.
 	 */
 	(void) strlcpy(nodep->am_ifname, ifname, sizeof (nodep->am_ifname));
 	(void) strlcpy(nodep->am_aobjname, aobjname,
@@ -279,10 +305,6 @@
 	nodep->am_lnum = lnum;
 	nodep->am_family = af;
 	nodep->am_atype = addrtype;
-	if (addrtype == IPADM_ADDR_IPV6_ADDRCONF) {
-		nodep->am_linklocal = B_TRUE;
-		nodep->am_ifid = addr;
-	}
 	nodep->am_next = NULL;
 
 	/*
@@ -297,8 +319,8 @@
 
 /*
  * Handles the door command IPMGMT_CMD_SETADDR. It adds a new address object
- * node to the list `aobjmap' and then persists the address information in the
- * DB.
+ * node to the list `aobjmap' and optionally persists the address
+ * information in the DB.
  */
 static void
 ipmgmt_setaddr_handler(void *argp)
@@ -305,7 +327,7 @@
 {
 	ipmgmt_setaddr_arg_t	*sargp = argp;
 	ipmgmt_retval_t		rval;
-	ipmgmt_aobjmap_t	node;
+	ipmgmt_aobjmap_t	node = {0};
 	nvlist_t		*nvl = NULL;
 	char			*nvlbuf;
 	size_t			nvlsize = sargp->ia_nvlsize;
@@ -321,11 +343,11 @@
 		if (flags & IPMGMT_INIT)
 			node.am_flags = (IPMGMT_ACTIVE|IPMGMT_PERSIST);
 		else
-			node.am_flags = flags;
+			node.am_flags = flags & ~IPMGMT_PROPS_ONLY;
 		if ((err = ipmgmt_aobjmap_op(&node, ADDROBJ_ADD)) != 0)
 			goto ret;
 	}
-	if (flags & IPMGMT_PERSIST) {
+	if ((flags & IPMGMT_PERSIST) && !(flags & IPMGMT_PROPS_ONLY)) {
 		ipadm_dbwrite_cbarg_t	cb;
 
 		cb.dbw_nvl = nvl;
@@ -339,7 +361,7 @@
 }
 
 /*
- * Handles the door commands that modify the `aobjmap' structure.
+ * Handles the door commands that read or modify the `aobjmap' structure.
  *
  * IPMGMT_CMD_ADDROBJ_LOOKUPADD - places a stub address object in `aobjmap'
  *	after ensuring that the namespace is not taken. If required, also
@@ -441,7 +463,7 @@
 			 * have am_ifid set.
 			 */
 			if (head->am_atype != IPADM_ADDR_IPV6_ADDRCONF ||
-			    head->am_linklocal) {
+			    head->ipmgmt_am_linklocal) {
 				break;
 			}
 		}
@@ -456,9 +478,8 @@
 		aobjrval.ir_family = head->am_family;
 		aobjrval.ir_flags = head->am_flags;
 		aobjrval.ir_atype = head->am_atype;
-		if (head->am_atype == IPADM_ADDR_IPV6_ADDRCONF &&
-		    head->am_linklocal)
-			aobjrval.ir_ifid = head->am_ifid;
+		(void) memcpy(&aobjrval.ir_atype_cache, &head->am_atype_cache,
+		    sizeof (aobjrval.ir_atype_cache));
 		(void) pthread_rwlock_unlock(&aobjmap.aobjmap_rwlock);
 		break;
 	case IPMGMT_CMD_LIF2ADDROBJ:
@@ -487,6 +508,8 @@
 		    sizeof (aobjrval.ir_aobjname));
 		aobjrval.ir_atype = head->am_atype;
 		aobjrval.ir_flags = head->am_flags;
+		(void) memcpy(&aobjrval.ir_atype_cache, &head->am_atype_cache,
+		    sizeof (aobjrval.ir_atype_cache));
 		(void) pthread_rwlock_unlock(&aobjmap.aobjmap_rwlock);
 		break;
 	default:
--- old/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_impl.h	Mon Nov 14 16:21:12 2016
+++ new/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_impl.h	Mon Nov 14 16:21:12 2016
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef	_IPMGMT_IMPL_H
@@ -103,8 +104,12 @@
  *	  of `aobjname'.
  *	- address type (static, dhcp or addrconf)
  *	- `am_flags' indicates if this addrobj in active and/or persist config
- *	- if `am_atype' is IPADM_ADDR_IPV6_ADDRCONF then `am_ifid' holds the
- *	  interface-id used to configure auto-configured addresses
+ *	- other, ipadm_addr_type_t-specific values are cached in
+ *	  am_addr_cache (see type ipmgmt_addr_cache_u):
+ *	  -	ipv6: ipmgmt_am_linklocal (macro)
+ *	  -	ipv6: ipmgmt_am_ifid (macro)
+ *	  -	dhcp: ipmgmt_am_primary (macro)
+ *	  -	dhcp: ipmgmt_am_reqhost (macro)
  */
 typedef struct ipmgmt_aobjmap_s {
 	struct ipmgmt_aobjmap_s	*am_next;
@@ -115,10 +120,14 @@
 	ipadm_addr_type_t	am_atype;
 	uint32_t		am_nextnum;
 	uint32_t		am_flags;
-	boolean_t		am_linklocal;
-	struct sockaddr_storage	am_ifid;
+	ipmgmt_addr_type_cache_u	am_atype_cache;
 } ipmgmt_aobjmap_t;
 
+#define	ipmgmt_am_linklocal	am_atype_cache.ipmgmt_ipv6_cache_s.ipmgmt_linklocal
+#define	ipmgmt_am_ifid		am_atype_cache.ipmgmt_ipv6_cache_s.ipmgmt_ifid
+#define	ipmgmt_am_primary	am_atype_cache.ipmgmt_dhcp_cache_s.ipmgmt_primary
+#define	ipmgmt_am_reqhost	am_atype_cache.ipmgmt_dhcp_cache_s.ipmgmt_reqhost
+
 /* linked list of `aobjmap' nodes, protected by RW lock */
 typedef struct ipmgmt_aobjmap_list_s {
 	ipmgmt_aobjmap_t	*aobjmap_head;
--- old/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_persist.c	Mon Nov 14 16:21:12 2016
+++ new/usr/src/cmd/cmd-inet/lib/ipmgmtd/ipmgmt_persist.c	Mon Nov 14 16:21:12 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2016 Argo Technologie SA.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 /*
@@ -908,7 +909,8 @@
 			if (strcmp(head->am_aobjname,
 			    nodep->am_aobjname) == 0 &&
 			    (head->am_atype != IPADM_ADDR_IPV6_ADDRCONF ||
-			    head->am_linklocal == nodep->am_linklocal))
+			    head->ipmgmt_am_linklocal ==
+			    nodep->ipmgmt_am_linklocal))
 				break;
 		}
 
@@ -920,10 +922,8 @@
 			head->am_family = nodep->am_family;
 			head->am_flags = nodep->am_flags;
 			head->am_atype = nodep->am_atype;
-			if (head->am_atype == IPADM_ADDR_IPV6_ADDRCONF) {
-				head->am_ifid = nodep->am_ifid;
-				head->am_linklocal = nodep->am_linklocal;
-			}
+			(void) memcpy(&head->am_atype_cache, &nodep->am_atype_cache,
+			    sizeof (head->am_atype_cache));
 		} else {
 			for (head = aobjmap.aobjmap_head; head != NULL;
 			    head = head->am_next) {
@@ -1068,29 +1068,41 @@
 	if ((err = nvlist_add_string(*nvl, ATYPE, strval)) != 0)
 		goto fail;
 
-	if (np->am_atype == IPADM_ADDR_IPV6_ADDRCONF) {
-		struct sockaddr_in6	*in6;
+	switch (np->am_atype) {
+		case IPADM_ADDR_IPV6_ADDRCONF: {
+			struct sockaddr_in6	*in6;
 
-		in6 = (struct sockaddr_in6 *)&np->am_ifid;
-		if (np->am_linklocal &&
-		    IN6_IS_ADDR_UNSPECIFIED(&in6->sin6_addr)) {
-			if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
-			    "default")) != 0)
-				goto fail;
-		} else {
-			if (inet_ntop(AF_INET6, &in6->sin6_addr, strval,
-			    IPMGMT_STRSIZE) == NULL) {
-				err = errno;
-				goto fail;
+			in6 = &np->ipmgmt_am_ifid;
+			if (np->ipmgmt_am_linklocal &&
+				IN6_IS_ADDR_UNSPECIFIED(&in6->sin6_addr)) {
+				if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
+					"default")) != 0)
+					goto fail;
+			} else {
+				if (inet_ntop(AF_INET6, &in6->sin6_addr, strval,
+					IPMGMT_STRSIZE) == NULL) {
+					err = errno;
+					goto fail;
+				}
+				if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
+					strval)) != 0)
+					goto fail;
 			}
-			if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
-			    strval)) != 0)
+		}
+			break;
+		case IPADM_ADDR_DHCP: {
+			if (np->ipmgmt_am_reqhost &&
+			    *np->ipmgmt_am_reqhost != '\0' &&
+			    (err = nvlist_add_string(*nvl, IPADM_NVP_REQHOST,
+			    np->ipmgmt_am_reqhost)) != 0)
 				goto fail;
 		}
-	} else {
-		if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
-		    "")) != 0)
-			goto fail;
+			/* FALLTHRU */
+		default:
+			if ((err = nvlist_add_string(*nvl, IPADM_NVP_IPNUMADDR,
+			    "")) != 0)
+				goto fail;
+			break;
 	}
 	return (err);
 fail:
@@ -1138,16 +1150,16 @@
 			node.am_atype = (ipadm_addr_type_t)atoi(strval);
 		} else if (strcmp(IPADM_NVP_IPNUMADDR, name) == 0) {
 			if (node.am_atype == IPADM_ADDR_IPV6_ADDRCONF) {
-				in6 = (struct sockaddr_in6 *)&node.am_ifid;
+				in6 = &node.ipmgmt_am_ifid;
 				if (strcmp(strval, "default") == 0) {
-					bzero(in6, sizeof (node.am_ifid));
-					node.am_linklocal = B_TRUE;
+					bzero(in6, sizeof (node.ipmgmt_am_ifid));
+					node.ipmgmt_am_linklocal = B_TRUE;
 				} else {
 					(void) inet_pton(AF_INET6, strval,
 					    &in6->sin6_addr);
 					if (IN6_IS_ADDR_UNSPECIFIED(
 					    &in6->sin6_addr))
-						node.am_linklocal = B_TRUE;
+						node.ipmgmt_am_linklocal = B_TRUE;
 				}
 			}
 		}
--- old/usr/src/cmd/cmd-inet/lib/nwamd/ncu.c	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/lib/nwamd/ncu.c	Mon Nov 14 16:21:13 2016
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <arpa/inet.h>
@@ -33,6 +34,7 @@
 #include <netinet/in.h>
 #include <stdlib.h>
 #include <strings.h>
+#include <sys/param.h>
 #include <sys/socket.h>
 #include <sys/time.h>
 #include <sys/types.h>
@@ -128,6 +130,17 @@
 	return (nwam_value_get_uint64_array(*val, uintval, cnt));
 }
 
+nwam_error_t
+nwamd_get_ncu_boolean(nwam_ncu_handle_t ncuh, nwam_value_t *val,
+    boolean_t **boolval, uint_t *cnt, const char *prop)
+{
+	nwam_error_t err;
+
+	if ((err = nwam_ncu_get_prop_value(ncuh, prop, val)) != NWAM_SUCCESS)
+		return (err);
+	return (nwam_value_get_boolean_array(*val, boolval, cnt));
+}
+
 /*
  * Run link/interface state machine in response to a state change
  * or enable/disable action event.
@@ -733,13 +746,13 @@
 {
 	nwamd_if_t *nif = &ncu_data->ncu_if;
 	struct nwamd_if_address **nifa, *nifai, *nifait;
-	boolean_t static_addr = B_FALSE;
+	boolean_t static_addr = B_FALSE, *boolvalue, dhcp_primary = B_FALSE;
 	uint64_t *addrsrcvalue;
 	nwam_value_t ncu_prop;
 	nwam_error_t err;
 	ipadm_addrobj_t ipaddr;
 	ipadm_status_t ipstatus;
-	char **addrvalue;
+	char **addrvalue, ipreqhost[MAXNAMELEN];
 	uint_t numvalues;
 	uint64_t *ipversion;
 	int i;
@@ -776,6 +789,39 @@
 		nwam_value_free(ncu_prop);
 	}
 
+	/* ip-primary */
+	if ((err = nwamd_get_ncu_boolean(ncuh, &ncu_prop, &boolvalue,
+	    &numvalues, NWAM_NCU_PROP_IP_PRIMARY)) != NWAM_SUCCESS) {
+		/* ip-primary is optional, so do not LOG_ERR */
+		nlog(LOG_DEBUG, "populate_ip_ncu_properties: "
+		    "could not get %s value: %s",
+		    NWAM_NCU_PROP_IP_PRIMARY, nwam_strerror(err));
+	} else {
+		if (numvalues > 0)
+			dhcp_primary = boolvalue[0];
+		nwam_value_free(ncu_prop);
+	}
+
+	/* ip-reqhost */
+	*ipreqhost = '\0';
+
+	if ((err = nwamd_get_ncu_string(ncuh, &ncu_prop, &addrvalue,
+	    &numvalues, NWAM_NCU_PROP_IP_REQHOST)) != NWAM_SUCCESS) {
+		/* ip-reqhost is optional, so do not LOG_ERR */
+		nlog(LOG_DEBUG, "populate_ip_ncu_properties: "
+		    "could not get %s value: %s",
+		    NWAM_NCU_PROP_IP_REQHOST, nwam_strerror(err));
+	} else {
+		if (numvalues > 0 && strlcpy(ipreqhost, addrvalue[0],
+		    sizeof (ipreqhost)) >= sizeof (ipreqhost)) {
+			nlog(LOG_WARNING, "populate_ip_ncu_properties: "
+			    "too long %s value: %s",
+			    NWAM_NCU_PROP_IP_REQHOST, addrvalue[0]);
+			*ipreqhost = '\0';
+		}
+		nwam_value_free(ncu_prop);
+	}
+
 	/* Free the old list. */
 	for (nifai = nif->nwamd_if_list; nifai != NULL; nifai = nifait) {
 		nifait = nifai->next;
@@ -828,6 +874,22 @@
 			ipadm_destroy_addrobj(ipaddr);
 			goto skip_ipv4_dhcp;
 		}
+		ipstatus = ipadm_set_primary(ipaddr, dhcp_primary);
+		if (ipstatus != IPADM_SUCCESS) {
+			nlog(LOG_ERR, "populate_ip_ncu_properties: "
+			    "ipadm_set_primary failed for v4 dhcp: %s",
+			    ipadm_status2str(ipstatus));
+			ipadm_destroy_addrobj(ipaddr);
+			goto skip_ipv4_dhcp;
+		}
+		ipstatus = ipadm_set_reqhost(ipaddr, ipreqhost);
+		if (ipstatus != IPADM_SUCCESS) {
+			nlog(LOG_ERR, "populate_ip_ncu_properties: "
+			    "ipadm_set_reqhost failed for v4 dhcp: %s",
+			    ipadm_status2str(ipstatus));
+			ipadm_destroy_addrobj(ipaddr);
+			goto skip_ipv4_dhcp;
+		}
 		if ((*nifa = calloc(sizeof (**nifa), 1)) != NULL) {
 			(*nifa)->family = AF_INET;
 			(*nifa)->ipaddr_atype = IPADM_ADDR_DHCP;
@@ -848,7 +910,7 @@
 		if ((err = nwamd_get_ncu_string(ncuh, &ncu_prop, &addrvalue,
 		    &numvalues, NWAM_NCU_PROP_IPV4_ADDR)) != NWAM_SUCCESS) {
 			nlog(LOG_ERR, "populate_ip_ncu_properties: "
-			    "could not get %s value; %s",
+			    "could not get %s value: %s",
 			    NWAM_NCU_PROP_IPV4_ADDR, nwam_strerror(err));
 		} else {
 			for (i = 0; i < numvalues; i++) {
@@ -995,7 +1057,7 @@
 		if ((err = nwamd_get_ncu_string(ncuh, &ncu_prop, &addrvalue,
 		    &numvalues, NWAM_NCU_PROP_IPV6_ADDR)) != NWAM_SUCCESS) {
 			nlog(LOG_ERR, "populate_ip_ncu_properties: "
-			    "could not get %s value; %s",
+			    "could not get %s value: %s",
 			    NWAM_NCU_PROP_IPV6_ADDR, nwam_strerror(err));
 		} else {
 			for (i = 0; i < numvalues; i++) {
--- old/usr/src/cmd/cmd-inet/lib/nwamd/ncu.h	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/lib/nwamd/ncu.h	Mon Nov 14 16:21:13 2016
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef _NCU_H
@@ -225,6 +226,8 @@
     uint64_t **, uint_t *, const char *);
 extern nwam_error_t nwamd_get_ncu_string(nwam_ncu_handle_t, nwam_value_t *,
     char ***, uint_t *, const char *);
+extern nwam_error_t nwamd_get_ncu_boolean(nwam_ncu_handle_t, nwam_value_t *,
+    boolean_t **, uint_t *, const char *);
 
 extern void nwamd_walk_physical_configuration(void);
 
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/Makefile	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/Makefile	Mon Nov 14 16:21:13 2016
@@ -21,6 +21,7 @@
 #
 # Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 
 PROG    = dhcpagent
@@ -45,7 +46,8 @@
 #
 
 CPPFLAGS  += -D_XOPEN_SOURCE=500 -D__EXTENSIONS__
-LDLIBS    += -lxnet -lnvpair -ldhcpagent -ldhcputil -linetutil -ldevinfo -ldlpi
+LDLIBS    += -lxnet -lnvpair -ldhcpagent -ldhcputil -linetutil -ldevinfo \
+	-ldlpi -lresolv -lsocket -lipadm
 
 # Disable warnings that affect all XPG applications.
 LINTFLAGS += -erroff=E_INCONS_ARG_DECL2 -erroff=E_INCONS_VAL_TYPE_DECL2
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/agent.c	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/agent.c	Mon Nov 14 16:21:13 2016
@@ -20,6 +20,7 @@
  */
 /*
  * Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <sys/types.h>
@@ -36,6 +37,8 @@
 #include <dhcpagent_ipc.h>
 #include <dhcpagent_util.h>
 #include <dhcpmsg.h>
+#include <dhcp_inittab.h>
+#include <dhcp_symbol.h>
 #include <netinet/dhcp.h>
 #include <net/route.h>
 #include <sys/sockio.h>
@@ -70,6 +73,10 @@
 static boolean_t	do_adopt = B_FALSE;
 static unsigned int	debug_level = 0;
 static iu_eh_callback_t	accept_event, ipc_event, rtsock_event;
+static void dhcp_smach_set_msg_reqhost(dhcp_smach_t *dsmp,
+		ipc_action_t *iap);
+static DHCP_OPT * dhcp_get_ack_or_state(const dhcp_smach_t *dsmp,
+		const PKT_LIST *plp, uint_t codenum, boolean_t *did_alloc);
 
 /*
  * The ipc_cmd_allowed[] table indicates which IPC commands are allowed in
@@ -754,6 +761,7 @@
 		break;		/* not an immediate function */
 
 	case DHCP_EXTEND:
+		dhcp_smach_set_msg_reqhost(dsmp, iap);
 		(void) dhcp_extending(dsmp);
 		break;
 
@@ -793,8 +801,8 @@
 				opt = dhcpv6_pkt_option(ack, NULL, optnum.code,
 				    NULL);
 			} else {
-				if (optnum.code <= DHCP_LAST_OPT)
-					opt = ack->opts[optnum.code];
+				opt = dhcp_get_ack_or_state(dsmp, ack, optnum.code,
+				    &did_alloc);
 			}
 			break;
 
@@ -876,11 +884,7 @@
 				if (optnum.code + optnum.size > sizeof (PKT))
 					break;
 
-				/*
-				 * + 2 to account for option code and length
-				 * byte
-				 */
-				opt = malloc(optnum.size + 2);
+				opt = malloc(optnum.size + DHCP_OPT_META_LEN);
 				if (opt != NULL) {
 					DHCP_OPT *v4opt = opt;
 
@@ -905,8 +909,7 @@
 		}
 
 		/*
-		 * return the option payload, if there was one.  the "+ 2"
-		 * accounts for the option code number and length byte.
+		 * return the option payload, if there was one.
 		 */
 
 		if (opt != NULL) {
@@ -916,7 +919,7 @@
 				(void) memcpy(&d6ov, opt, sizeof (d6ov));
 				optlen = ntohs(d6ov.d6o_len) + sizeof (d6ov);
 			} else {
-				optlen = ((DHCP_OPT *)opt)->len + 2;
+				optlen = ((DHCP_OPT *)opt)->len + DHCP_OPT_META_LEN;
 			}
 			send_data_reply(iap, 0, DHCP_TYPE_OPTION, opt, optlen);
 
@@ -971,6 +974,7 @@
 		PKT_LIST *plp[2];
 
 		deprecate_leases(dsmp);
+		dhcp_smach_set_msg_reqhost(dsmp, iap);
 
 		/*
 		 * if we have a valid hostconf lying around, then jump
@@ -1058,6 +1062,143 @@
 	}
 }
 
+/*
+ * dhcp_smach_set_msg_reqhost(): set dsm_msg_reqhost based on the message
+ * content of a DHCP IPC message
+ *
+ *   input: dhcp_smach_t *: the state machine instance;
+ *	    ipc_action_t *: the decoded DHCP IPC message;
+ *  output: void
+ */
+
+static void
+dhcp_smach_set_msg_reqhost(dhcp_smach_t *dsmp, ipc_action_t *iap)
+{
+	if (dsmp->dsm_msg_reqhost != NULL) {
+		dhcpmsg(MSG_DEBUG,
+		    "dhcp_smach_set_msg_reqhost: nullify former value, %s",
+		    dsmp->dsm_msg_reqhost);
+		free(dsmp->dsm_msg_reqhost);
+		dsmp->dsm_msg_reqhost = NULL;
+	}
+	free(dsmp->dsm_reqfqdn);
+	dsmp->dsm_reqfqdn = NULL;
+
+	/*
+	 * if a STANDARD/HOSTNAME was sent in the IPC request, then copy that
+	 * value into the state machine data if decoding succeeds. Otherwise,
+	 * log to indicate at what step the decoding stopped.
+	 */
+
+	if (dsmp->dsm_isv6) {
+		dhcpmsg(MSG_DEBUG, "dhcp_smach_set_msg_reqhost: ipv6 is not"
+		    " handled");
+	} else if (iap->ia_request->data_type != DHCP_TYPE_OPTION) {
+		dhcpmsg(MSG_DEBUG, "dhcp_smach_set_msg_reqhost: request type %d is"
+		    " not DHCP_TYPE_OPTION", iap->ia_request->data_type);
+	} else {
+		if (iap->ia_request->buffer == NULL
+		    || iap->ia_request->data_length <= DHCP_OPT_META_LEN) {
+			dhcpmsg(MSG_WARNING, "dhcp_smach_set_msg_reqhost:"
+			    " DHCP_TYPE_OPTION ia_request buffer is NULL (0) or"
+			    " short (1): %d",
+			    iap->ia_request->buffer == NULL ? 0 : 1);
+		} else {
+			DHCP_OPT *d4o = (DHCP_OPT *)iap->ia_request->buffer;
+
+			if (d4o->code != CD_HOSTNAME)
+			{
+				dhcpmsg(MSG_DEBUG,
+				    "dhcp_smach_set_msg_reqhost: ignoring DHCPv4"
+				    " option %u", d4o->code);
+			} else if (iap->ia_request->data_length - DHCP_OPT_META_LEN
+			    != d4o->len) {
+				dhcpmsg(MSG_WARNING, "dhcp_smach_set_msg_reqhost:"
+				    " unexpected DHCP_OPT buffer length %u for CD_HOSTNAME"
+				    " option length %u", iap->ia_request->data_length,
+				    d4o->len);
+			} else {
+
+				dhcp_symbol_t *entry = inittab_getbycode(ITAB_CAT_STANDARD,
+				    ITAB_CONS_INFO, CD_HOSTNAME);
+				if (entry == NULL) {
+					dhcpmsg(MSG_WARNING,
+					    "dhcp_smach_set_msg_reqhost: error getting"
+					    " ITAB_CAT_STANDARD ITAB_CONS_INFO"
+					    " CD_HOSTNAME entry");
+				} else {
+					char *value = inittab_decode(entry, d4o->value,
+					    d4o->len, /* just_payload */ B_TRUE);
+					if (value == NULL) {
+						dhcpmsg(MSG_WARNING,
+						    "dhcp_smach_set_msg_reqhost: error decoding"
+						    " CD_HOSTNAME value from DHCP_OPT");
+					} else {
+						dhcpmsg(MSG_DEBUG,
+						    "dhcp_smach_set_msg_reqhost: host %s", value);
+						free(dsmp->dsm_msg_reqhost);
+						dsmp->dsm_msg_reqhost = value;
+					}
+					free(entry);
+					entry = NULL;
+				}
+			}
+		}
+	}
+}
+
+/*
+ * dhcp_get_ack_or_state(): get a v4 option from the ACK or from the state
+ * machine state for certain codes that are not ACKed (e.g., CD_CLIENT_ID)
+ *
+ *   input: dhcp_smach_t *: the state machine instance;
+ *	    PKT_LIST *: the decoded DHCP IPC message;
+ *	    uint_t: the DHCP client option code;
+ *	    boolean_t *: a pointer to a value that will be set to B_TRUE if
+ *	        the return value must be freed (or else set to B_FALSE);
+ *  output: the option if found or else NULL.
+ */
+
+/* ARGSUSED */
+static DHCP_OPT *
+dhcp_get_ack_or_state(const dhcp_smach_t *dsmp, const PKT_LIST *plp,
+	uint_t codenum, boolean_t *did_alloc)
+{
+	DHCP_OPT *opt;
+
+	*did_alloc = B_FALSE;
+
+	if (codenum > DHCP_LAST_OPT)
+		return NULL;
+
+	/* check the ACK first for all codes */
+	opt = plp->opts[codenum];
+	if (opt != NULL)
+		return opt;
+
+	/* check the machine state also for certain codes */
+	switch (codenum) {
+	case CD_CLIENT_ID:
+		/*
+		 * CD_CLIENT_ID is not sent in an ACK, but it's possibly available
+		 * from the state machine data
+		 */
+
+		if (dsmp->dsm_cidlen > 0) {
+			if ((opt = malloc(dsmp->dsm_cidlen + DHCP_OPT_META_LEN))
+			    != NULL) {
+				*did_alloc = B_TRUE;
+				(void) encode_dhcp_opt(opt, B_FALSE /* is IPv6 */,
+				    CD_CLIENT_ID, dsmp->dsm_cid, dsmp->dsm_cidlen);
+			}
+		}
+		break;
+	default:
+		break;
+	}
+	return (opt);
+}
+
 /*
  * check_rtm_addr(): determine if routing socket message matches interface
  *		     address
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/defaults.c	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/defaults.c	Mon Nov 14 16:21:13 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #include <sys/types.h>
@@ -59,7 +60,9 @@
 	{ "DEBUG_LEVEL",	 "0",	 0,   3   },
 	{ "VERBOSE",		 "0",	 0,   0   },
 	{ "VERIFIED_LEASE_ONLY", "0",	 0,   0	  },
-	{ "PARAM_IGNORE_LIST",	 NULL,	 0,   0   }
+	{ "PARAM_IGNORE_LIST",	 NULL,	 0,   0   },
+	{ "REQUEST_FQDN",	 "1",	 0,   0	  },
+	{ "V4_DEFAULT_IAID_DUID",  "0",	 0,   0	  },
 };
 
 /*
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/defaults.h	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/defaults.h	Mon Nov 14 16:21:13 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #ifndef	DEFAULTS_H
@@ -54,7 +55,9 @@
 	DF_DEBUG_LEVEL,		/* set debug level (undocumented) */
 	DF_VERBOSE,		/* set verbose mode (undocumented) */
 	DF_VERIFIED_LEASE_ONLY,	/* send RELEASE on SIGTERM and need verify */
-	DF_PARAM_IGNORE_LIST	/* our parameter ignore list */
+	DF_PARAM_IGNORE_LIST,	/* our parameter ignore list */
+	DF_REQUEST_FQDN,	/* request client FQDN associated with interface */
+	DF_V4_DEFAULT_IAID_DUID	/* always IAID/DUID if no DF_CLIENT_ID */
 };
 
 #define	DHCP_AGENT_DEFAULTS	"/etc/default/dhcpagent"
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/dhcpagent.dfl	Mon Nov 14 16:21:13 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/dhcpagent.dfl	Mon Nov 14 16:21:13 2016
@@ -22,6 +22,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
 #
 
 #
@@ -90,16 +91,55 @@
 #
 # CLIENT_ID=
 
+# By default, for an IPv4 interface that is not in an IP network
+# multipathing (IPMP) group, that is not IP over InfiniBand (IPoIB), and
+# that is not a logical interface, the DHCP agent will forgo sending a
+# client identifier unless CLIENT_ID is defined.
+#
+# To use a system-managed, RFC 3315-style (i.e., DHCPv6-style) binding
+# identifier as documented in RFC 4361, "Node-specific Client Identifiers
+# for DHCPv4," for all IPv4 interfaces (unless CLIENT_ID is defined),
+# uncomment the following line.
+#
+# V4_DEFAULT_IAID_DUID=yes
+
+# By default, the DHCP agent will try to request the Fully Qualified Domain
+# Name (FQDN) currently associated with the interface performing DHCP.  The
+# hostname is defined by using the -h,--reqhost option of ipadm(1M) or the
+# ncu ip-reqhost property of nwamcfg(1M) or by flagging the interface as
+# primary so that nodename(4) is used as the hostname.
+#
+# A defined hostname will be used as the FQDN if it is "rooted" (i.e., if
+# it ends with a '.') or if it consists of at least three DNS labels (e.g.,
+# srv.example.com).  If the hostname is not an FQDN, then either a defined
+# defaultdomain(4) or a defined resolv.conf(4) domain will be appended to
+# form an FQDN.  If no FQDN can be determined, the option will not be used.
+#
+# If this REQUEST_FQDN option is enabled, an FQDN will be sent in messages
+# to the DHCP server along with RFC 4702 options to request that a
+# collaborating DNS server perform DNS updates for A and PTR resource
+# records.  To prevent sending FQDN and DNS options, uncomment the line
+# below.
+#
+# If an FQDN is sent, REQUEST_HOSTNAME processing will not be done, per RFC
+# 4702 (3.1):  "clients that send the Client FQDN option in their messages
+# MUST NOT also send the Host Name."
+#
+# REQUEST_FQDN=no
+
 # By default, the DHCP agent will try to request the hostname currently
 # associated with the interface performing DHCP.  If this option is
-# enabled, the agent will attempt to find a host name in /etc/hostname.<if>,
-# which must contain a line of the form
+# enabled, the agent will attempt to use an -h,--reqhost option saved with
+# ipadm(1M) or an ncu ip-reqhost property set with nwamcfg(1M); or else
+# attempt to find a host name in /etc/hostname.<if>, which must contain a
+# line of the form
 #
 #	inet name
 #
-# where "name" is a single RFC 1101-compliant token.  If found, the token
-# will be used to request that host name from the DHCP server.  To prevent
-# this, uncomment the following line.
+# where "name" is a single RFC 1101-compliant token; or else use
+# nodename(4) for a DHCP interface flagged as primary.  If found in any of
+# these configurations, the token will be used to request that host name
+# from the DHCP server.  To prevent this, uncomment the following line.
 #
 # REQUEST_HOSTNAME=no
 
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/init_reboot.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/init_reboot.c	Mon Nov 14 16:21:14 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  *
  * INIT_REBOOT state of the DHCP client state machine.
  */
@@ -27,7 +28,6 @@
 
 #include <sys/types.h>
 #include <stdio.h>
-#include <limits.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <netinet/dhcp.h>
@@ -58,8 +58,6 @@
 dhcp_init_reboot_v4(dhcp_smach_t *dsmp)
 {
 	dhcp_pkt_t		*dpkt;
-	const char		*reqhost;
-	char			hostfile[PATH_MAX + 1];
 
 	/*
 	 * assemble DHCPREQUEST message.  The max dhcp message size
@@ -79,30 +77,9 @@
 		(void) add_pkt_opt(dpkt, CD_CLASS_ID, class_id, class_id_len);
 	(void) add_pkt_prl(dpkt, dsmp);
 
-	/*
-	 * Set CD_HOSTNAME option if REQUEST_HOSTNAME is set and a hostname
-	 * is found in /etc/hostname.<ifname>
-	 */
-	if (df_get_bool(dsmp->dsm_name, dsmp->dsm_isv6, DF_REQUEST_HOSTNAME)) {
-		(void) snprintf(hostfile, sizeof (hostfile), "/etc/hostname.%s",
-		    dsmp->dsm_name);
+	if (dhcp_add_fqdn_opt(dpkt, dsmp) != 0)
+		(void) dhcp_add_hostname_opt(dpkt, dsmp);
 
-		if ((reqhost = iffile_to_hostname(hostfile)) != NULL) {
-			dhcpmsg(MSG_DEBUG, "dhcp_selecting: host %s", reqhost);
-			if ((dsmp->dsm_reqhost = strdup(reqhost)) != NULL)
-				(void) add_pkt_opt(dpkt, CD_HOSTNAME,
-				    dsmp->dsm_reqhost,
-				    strlen(dsmp->dsm_reqhost));
-			else
-				dhcpmsg(MSG_WARNING, "dhcp_selecting: cannot"
-				    " allocate memory for host name option");
-		} else {
-			dhcpmsg(MSG_DEBUG,
-			    "dhcp_selecting: no hostname for %s",
-			    dsmp->dsm_name);
-		}
-	}
-
 	(void) add_pkt_opt(dpkt, CD_END, NULL, 0);
 
 	(void) send_pkt(dsmp, dpkt, htonl(INADDR_BROADCAST), stop_init_reboot);
@@ -182,6 +159,9 @@
 	/* Add required Option Request option */
 	(void) add_pkt_prl(dpkt, dsmp);
 
+	/* Add FQDN if configured */
+	(void) dhcp_add_fqdn_opt(dpkt, dsmp);
+
 	(void) send_pkt_v6(dsmp, dpkt, ipv6_all_dhcp_relay_and_servers,
 	    stop_init_reboot, DHCPV6_CNF_TIMEOUT, DHCPV6_CNF_MAX_RT);
 
--- old/usr/src/cmd/cmd-inet/sbin/dhcpagent/ipc_action.c	Mon Nov 14 16:21:14 2016
+++ new/usr/src/cmd/cmd-inet/sbin/dhcpagent/ipc_action.c	Mon Nov 14 16:21:14 2016
@@ -21,6 +21,7 @@
 /*
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2016, Chris Fraire <cfraire@me.com>.
  */
 
 #pragma ident	"%Z%%M%	%I%	%E% SMI"
@@ -106,8 +107,10 @@
 	/* We've taken ownership, so the input request is now invalid */
 	ipc_action_init(iareq);
 
-	dhcpmsg(MSG_DEBUG, "ipc_action_start: started %s (command %d) on %s",
-	    dhcp_ipc_type_to_string(ia->ia_cmd), ia->ia_cmd, dsmp->dsm_name);
+	dhcpmsg(MSG_DEBUG, "ipc_action_start: started %s (command %d) on %s,"
+	    " buffer length %u",
+	    dhcp_ipc_type_to_string(ia->ia_cmd), ia->ia_cmd, dsmp->dsm_name,
+	    ia->ia_request == NULL ? 0 : ia->ia_request->data_length);
 
 	dsmp->dsm_dflags |= DHCP_IF_BUSY;
 
